####################CODE FOR POISSON MODEL AND OTHER PLOTS
##FIG 2
par(mfrow=c(2,3))
coll=c("red","green","blue","black")
time=c(10000,20000,30000,40000,50000,60000,70000,80000,90000,100000,110000,120000,130000,140000,
150000,160000,170000,180000,190000,200000)
shear=c(0.1254993,0.1463607,0.1574704,0.1940852,0.2135950,0.2235060,0.2646034,0.2798997,0.2937093,
0.2957474,0.3003246,0.3061300,0.3245075,0.3409109,0.3489085,0.3511842,0.3559263,0.3593931,0.3683527,0.3711353)
ind=c(7,13,12,20,9,10,6,17,14,3,8,11,2,4,16,19,18,5,1,15)
s=c(0.16,0.26,0.28,0.37)
id=c(12,6,17,15)
noe2=as.matrix(read.csv("noe2.csv",header=TRUE))
noes2=as.matrix(read.csv("noes2.csv",header=TRUE))
noe1=noe2[id,]
noe2=noes2[id,]
#
dat=t(apply(t(noe1),2,summary))
barplot(dat,beside=TRUE,ylab = 'Number of shear events per 10,000s',main ="Distribution of number of shear events",cex.axis=1.7,cex.lab=1.7,cex.main=1.8,legend=paste("shear rate",paste(s,"1/s"),sep="="),args.legend = list(x = "topleft",cex=1.8),col=coll)
####
y1=min(noe1+noe2,noe1-noe2)
y2=max(noe1+noe2,noe1-noe2)
coll=c("red","green","blue","black")
for(k in 1:4){
library(plotrix)
F=round(noe1[k,])
U=F+round(noe2[k,])
L=F-round(noe2[k,])
plotCI(time,F,ui=U,li=L,ylab="Number of events per 10,000 time steps"
,xlab="Time (s)",main="Number of shear events",cex=1.8,cex.lab=1.7,cex.axis=1.7,
cex.main=1.8,col=coll[k],scol=coll[k],slty=1,lwd=2,ylim=c(y1,y2+1),xlim=c(10000,200000))
lines(time,F,col=coll[k],ylab="",xlab="",lty=1,lwd=2)
par(new=TRUE)
}
legend("topright",paste("shear rate",paste(s,"1/s"),sep="="),
fill=c("red","green","blue","black"),bty="0",border="black",cex=1.8,horiz=FALSE)
########no of events over shear
noe2=as.matrix(read.csv("noe2.csv",header=TRUE))
noes2=as.matrix(read.csv("noes2.csv",header=TRUE))
shear=c(0.1254993,0.1463607,0.1574704,0.1940852,0.2135950,0.2235060,0.2646034,0.2798997,0.2937093,
0.2957474,0.3003246,0.3061300,0.3245075,0.3409109,0.3489085,0.3511842,0.3559263,0.3593931,0.3683527,0.3711353)
ind=c(7,13,12,20,9,10,6,17,14,3,8,11,2,4,16,19,18,5,1,15)
q1=rowMeans(noe2)
q2=rowMeans(noes2)
F=q1[ind]
U=F+(q2[ind])
L=F-(q2[ind])
y1=min(F,U,L)
y2=max(F,U,L)
plotCI(shear,F,ui=U,li=L,ylab="Number of shear events"
,xlab="Shear rate (1/s)",main="Number of shear events",cex=1.8,slty=1,cex.lab=1.7,cex.axis=1.7,cex.main=1.8,lwd=2,ylim=c(y1,y2))
lines(shear,F,ylab="",xlab="",lty=1,lwd=2)
############
volume=as.matrix(read.csv("volume.csv",header=TRUE))
volumes=as.matrix(read.csv("volume.csv",header=TRUE))
v1=volume[id,]
v2=volumes[id,]
v0=v1
dat=t(apply(t(v0),2,summary))
barplot(dat,beside=TRUE,ylab = 'Detached cluster volume',main ="Distribution of detached cluster volume",cex.axis=1.7,cex.lab=1.7,cex.main=1.8,legend=paste("shear rate",paste(s,"1/s"),sep="="),args.legend = list(x = "topleft",cex=1.8),col=coll)
####
y1=min(v1+v2,v1-v2)
y2=max(v1+v2,v1-v2)
coll=c("red","green","blue","black")
for(k in 1:4){
library(plotrix)
F=(v1[k,])
U=F+(v2[k,])
L=F-(v2[k,])
plotCI(time,F,ui=U,li=L,ylab="Detached cluster volume"
,xlab="Time (s)",main="Volume of detached clusters",cex=1.8,cex.lab=1.7,cex.axis=1.7,
cex.main=1.8,col=coll[k],scol=coll[k],slty=1,lwd=.1,ylim=c(y1,y2),xlim=c(10000,200000))
lines(time,F,col=coll[k],ylab="",xlab="",lty=1,lwd=2)
par(new=TRUE)
}
legend("topright",paste("shear rate",paste(s,"1/s"),sep="="),
fill=c("red","green","blue","black"),bty="0",border="black",cex=1.8,horiz=FALSE)
###########
voll=rowSums(volume[,1:20])[ind]
volls=rowSums(volumes[,1:20])[ind]
F=voll
U=F[]+(volls[])
L=F[]-(volls[])
y1=min(F,U,L)
y2=max(F,U,L)
plotCI(shear,F[],ui=U,li=L,ylab="Detached cluster"
,xlab="Shear rate (1/s)",main="Total volume of detached clusters",cex=1.8,cex.lab=1.7,cex.axis=1.7,cex.main=1.8,lwd=2,ylim=c(y1,y2))
lines(shear,F,ylab="",xlab="",lty=1,lwd=2)

####################################################POISSON MODEL
input=as.matrix(read.csv("input.csv",header=TRUE))
input2=as.matrix(read.csv("input2.csv",header=TRUE))
resp=as.matrix(read.csv("resp.csv",header=TRUE))
resp2=c(as.matrix(read.csv("resp2.csv",header=TRUE)))
library(MCMCpack)
nam=c("noe","height","compeps","nparticle","mass","time","shear")
set.seed(12345)
ntime=20
ll=20
N1=1000###burnin
N2=6000000##number of mcmc
N3=1000
load("polyset")
input=as.data.frame(input)
input2=as.data.frame(input2)
quadterms=polySet((ncol(input)),2,2,2)
quad <-formula(paste("resp~", makeScope(quadterms,c(nam[-1]))))
mod <- glm(formula =quad, data =input, family = poisson)
mod1 <- MCMCpoisson(quad,data=input,burnin=N1,mcmc =N2,thin=N3,verbose=1,b0=0.5,B0=0,beta.start=coef(mod))
path=getwd()
save(mod1,file=paste(path,"mod1",sep="/"))

cf=summary(mod1)[1]$statistics
coef=stack(colMeans(mod1[-c(1:N3),]))[,1]
#coef=coef(mod)
xnam=colnames(mod1)[-1]
ff=function(newdata){
(form1 <- as.formula(paste("~", paste(xnam, collapse= "+"))))
mm=model.matrix(form1,data.frame(newdata))
y0=round(exp(c(coef %*% t(mm))))
}
X0=as.matrix(cbind(1,input))
x0=as.matrix(cbind(1,input2))
lambda=ff(x0)
res1=res2=list()
##predictions by sampling from Poisson distribution
for(j in 1:length(lambda)){
res1[[j]]=mean(rpois(N1,lambda[j]))
res2[[j]]=sd(rpois(N1,lambda[j]))
}
emu=abind(res1,along=1)
dev=abind(res2,along=1)
#
lambda2=ff(X0)
res1=res2=list()
for(j in 1:length(lambda2)){
res1[[j]]=mean(rpois(N1,lambda2[j]))
res2[[j]]=sd(rpois(N1,lambda2[j]))
}
yhat=abind(res1,along=1)
noee=c(yhat,emu)
#save(noee,file=paste(path,"noee",sep="/"))
mse=sqrt(sum((resp-yhat)^2)/nrow(input))
cor(emu,resp2)^2
lammp=resp2
P=1-(sum((lammp-emu)^2)/sum((lammp- mean(lammp))^2))
RMSE=sqrt(mean((lammp-emu)^2))##RMSE=1.75
ntime=10
emu0=matrix(emu,ntime,ll)
ss=matrix(dev,ntime,ll)
lam=matrix(lammp,ntime,ll)

###########
s=c(0.31,0,0,0,0.37,0,0.28,0,0.35,0)
library(plotrix)
par(mfrow=c(2,2))
for(k in c(7,1,9,5)){
emu1=emu0[k,]
lam1=lam[k,]
sss=2*ss[k,]##95%
dev1=emu1+sss
dev2=emu1-sss
y1=min(dev1,dev2,emu1,lam1)
y2 = max(dev1,dev2,emu1,lam1)
y1=y1-1;y2=y2+1
ttime=c(10000,20000,30000,40000,50000,60000,70000,80000,90000,100000,110000,120000,130000,140000,
150000,160000,170000,180000,190000,200000)
F=emu1
U=dev1
L=dev2
plotCI(ttime,F,ui=U,li=L,cex.lab=1.5,cex.axis=1.6,xlab="Time (s)",col="green",scol="red",
cex.main=1.7,slty=3,ylim=c(y1,y2),ylab="Number of event",main="Number of shearing event per 10000s")
lines(ttime,F,ylab="",xlab="",lwd=3,col="green")
lines(ttime,lam1,"o",lwd=1,xlab="time (s)",ylab="",xlab="",cex.lab=1.5,cex.axis=1.6,cex.main=1.7,ylim=c(y1,y2))
legend("topright",c(paste("Shear rate",paste(s[k],"1/s"),sep="="),"Prediction","Simulation","95% C.I"),fill=c("white","green","black","red"),cex=1.6)
}
#################FIG 4
i=c(2,7,6)
Psi=mod1[,i]
title=c("Shear rates","Biofilm height","EPS composition")#colnames(mod1[])
burn=1
library(dlm)
par(mar = c(4, 4, 3, 1) + 0.1, cex = 1.1)
par(mfrow=c(3,3))
for(j in 1:3){
#par(mar = c(2, 4, 1, 1) + 0.1, cex = 0.6)
hist(Psi[-(1:burn),j],prob=T, main=paste(title[3+j-3]),xlab="",col="green")
lines(density(Psi[-(1:burn),j]),xlab=paste(title[3+j-3]),col="red")
ts.plot(ergMean(Psi[-c(1:burn),j]),xlab="Iterations",ylab="ErgMean",col="red")
ts.plot(Psi[-(1:burn),j], main="",ylab="Traceplots",col="blue",xlab="Iterations")
}
########
